package	jp.co.sds_corp.tool;

import java.text.ParseException;

public class Where
{
	public enum Operator {
		EQ, NEQ, LT, LTE, GT, GTE
	};
	Operator operator;
	String key;
	String value;

	public Where(String where) throws ParseException {
		parseWhere(where);
	}

	void parseWhere(String where) throws ParseException {
		String op = null;
		if (where.indexOf("!=") >= 0) {
			operator = Operator.NEQ;
			op = "!=";
		} else
		if (where.indexOf("<=") >= 0) {
			operator = Operator.LTE;
			op = "<=";
		} else
		if (where.indexOf("<") >= 0) {
			operator = Operator.LT;
			op = "<";
		} else
		if (where.indexOf(">=") >= 0) {
			operator = Operator.GTE;
			op = ">=";
		} else
		if (where.indexOf(">") >= 0) {
			operator = Operator.GT;
			op = ">";
		} else
		if (where.indexOf("=") >= 0) {
			operator = Operator.EQ;
			op = "=";
		}
		if (op == null) {
			throw( new ParseException("operator not found.", -1));
		}
		String[] arr = where.split(op);
		key = arr[0].trim();
		value = arr[1].trim();
	}

	public String getKey() {
		return this.key;
	}

	public String getValue() {
		return this.value;
	}

	public Operator getOperator() {
		return this.operator;
	}

	public boolean match(String var) {
		if (value == null) {
			if (operator == Operator.EQ && var == null) {
				return true;
			}
			return false;
		}
		if (var == null) {
			return false;
		}

		boolean ret = false;
		switch(operator) {
		case EQ:
			ret = value.equals(var);
			break;
		case NEQ:
			ret = !value.equals(var);
			break;
		case LTE:
			ret = (value.compareTo(var) >= 0);
			break;
		case LT:
			ret = (value.compareTo(var) > 0);
			break;
		case GTE:
			ret = (value.compareTo(var) <= 0);
			break;
		case GT:
			ret = (value.compareTo(var) < 0);
			break;
		}
		return ret;
	}

}
