package jp.co.sds_corp.tool.check;

public class RequestException extends Exception
{
	private static final long serialVersionUID = -5539772655155920718L;
	int responseCode;
	String responseMessage;

	public RequestException(String msg) {
		super(msg);
	}

	public RequestException(String msg, int responseCode) {
		this(msg);
		this.responseCode = responseCode;
	}

	public RequestException(String msg, int responseCode, String responseMessage) {
		this(msg);
		this.responseCode = responseCode;
		this.responseMessage = responseMessage;
	}

	public String toString() {
		String ret = super.toString();
		ret += " response=" + responseCode;
		if (responseMessage != null) {
			ret += ":" + responseMessage;
		}
		return ret;
	}

}
