package	jp.co.sds_corp.tool.security;

import java.io.BufferedReader;
import java.io.FileReader;
import java.net.InetAddress;
import java.util.Iterator;
import java.util.TreeMap;

/**
* /var/log/secure.* ファイルをチェックして、攻撃者のIPアドレスをリストアップします。
*/
public class ListAttacker
{
	boolean	desc = false;
	boolean	show = false;

	class Attacker
	{
		String	address;
		boolean	already;
		int		count;
	}
	TreeMap<String,Attacker> mapAtc = new TreeMap<String,Attacker>();

	public void setShow( boolean var ) {
		show = var;
	}
	public void setShowDescription( boolean var ) {
		desc = var;
	}

	public void start() throws Exception {
		readDeny();
		readSecure();
		Iterator<String> itr = mapAtc.keySet().iterator();
		while ( itr.hasNext()) {
			Object key = itr.next();
			Attacker atc = (Attacker )mapAtc.get( key );
			InetAddress ia = InetAddress.getByName( atc.address );
			if ( show ) {
				if ( desc ) {
					System.out.println( ia.getHostName() + "\t"
						+ ( atc.already ? "T" : "F" ) + "\t"
						+ atc.count );
				} else {
					System.out.println( atc.address + "\t"
						+ ( atc.already ? "T" : "F" ) + "\t"
						+ atc.count );
				}
			} else {
				if ( atc.count > 5 ) {
					System.out.println( "ALL: " + atc.address );
				}
			}
		}
	}

	private void readDeny() throws Exception {
		BufferedReader br = new BufferedReader(
			new FileReader( "/etc/hosts.deny" ));
		for ( ;; ) {
			String line = br.readLine();
			if ( line == null ) {
				break;
			}
			int idx = line.indexOf( "#" );
			if ( idx >= 0 ) {
				line = line.substring( 0, idx );
			}
			if ( line.length() < 6 ) {
				continue;
			}
			String addr = line.substring( 5 );
			Attacker atc = new Attacker();
			atc.address = addr;
			atc.already = true;
			mapAtc.put( addr, atc );
		}
		br.close();
	}

	private void readSecure() throws Exception {
		for ( int i = -1; i < 9; i++ ) {
			String f = "/var/log/secure";
			if ( i >= 0 ) {
				f = f + "." + i;
			}
			BufferedReader br;
			try {
				br = new BufferedReader( new FileReader( f ));
			} catch ( Exception e ) {
				continue;
			}
			for ( ;; ) {
				String line = br.readLine();
				if ( line == null ) {
					break;
				}
				if ( line.indexOf( "sshd" ) < 0 ||
					line.indexOf( "Failed password for " ) < 0 )
				{
					continue;
				}
				int idx1 = line.indexOf( "from " );
				if ( idx1 < 0 ) {
					continue;
				}
				int idx2 = line.indexOf( " port " );
				if ( idx2 < 0 ) {
					continue;
				}
				String addr = line.substring( idx1 + 5, idx2 );
				Attacker atc = (Attacker )mapAtc.get( addr );
				if ( atc == null ) {
					atc = new Attacker();
					atc.address = addr;
					atc.already = false;
				}
				atc.count++;
				mapAtc.put( addr, atc );
			}
			br.close();
		}
	}

	public static void main( String[] args ) {
		try {
			ListAttacker obj = new ListAttacker();
			if ( args.length > 0 ) {
				if ( args[0].equals( "-s" )) {
					obj.setShow( true );
				}
				if ( args[0].equals( "-d" )) {
					obj.setShow( true );
					obj.setShowDescription( true );
				}
			}
			obj.start();
		} catch ( Exception e ) {
		}
	}
}

