package jp.co.sds_corp.tool.test;

import java.util.Date;
import jp.co.sds_corp.util.log.CmnLogger;

public class StressResult
{
	static CmnLogger logger = CmnLogger.getInstance();
	Date start;
	Date end;
	long time;

	public synchronized void start() {
		time = -1;
		start = new Date();
		end = null;
	}

	public synchronized void end() {
		if (start == null) {
			logger.warn(this, "test result ommitted.");
			return;
		}
		count++;
		end = new Date();
		time = end.getTime() - start.getTime();
		totalTime += time;
		if ( minTime > time ) {
			minTime = time;
		}
		if ( maxTime < time ) {
			maxTime = time;
		}
	}

	public synchronized boolean isRunning() {
		if (start != null && end == null) {
			return true;
		}
		return false;
	}

	public synchronized void clear() {
		count = 0;
		start = null;
		end = null;
		time = -1;
		totalTime  = 0;
		minTime = Long.MAX_VALUE;
		maxTime = Long.MIN_VALUE;
	}

	int	count;	// テスト回数
	long	totalTime;	// 合計処理時間
	long	minTime = Long.MAX_VALUE;	// 最小処理時間
	long	maxTime = Long.MIN_VALUE;	// 最大処理時間

	/**
	* テスト回数を設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setCount( int var ) {
		this.count = var;
	}
	/**
	* テスト回数を取得します。
	* @return	テスト回数
	*/
	public synchronized int getCount() {
		return count;
	}

	/**
	* 合計処理時間を設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setTotalTime( long var ) {
		this.totalTime = var;
	}
	/**
	* 合計処理時間を取得します。
	* @return	合計処理時間
	*/
	public synchronized long getTotalTime() {
		return totalTime;
	}

	/**
	* 最小処理時間を設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setMinTime( long var ) {
		this.minTime = var;
	}
	/**
	* 最小処理時間を取得します。
	* @return	最小処理時間
	*/
	public synchronized long getMinTime() {
		return minTime;
	}

	/**
	* 最大処理時間を設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setMaxTime( long var ) {
		this.maxTime = var;
	}
	/**
	* 最大処理時間を取得します。
	* @return	最大処理時間
	*/
	public synchronized long getMaxTime() {
		return maxTime;
	}

}
